function debug( message ) {
    //if ( window.ProcessKiller ) {
    ProcessKiller.logMessage( message.toString() );
//     } else {
//         document.getElementById( "debug" ).innerText = message.toString();
//     }
}
var scroller = null;
var refreshTimer = null;
var refreshInterval = 5000;
var selectedProcess = null;
var selectedBackground = "#063";
var selectedForeground = "white";
var userName = null;
var maxNameLength = 20;
function init() {
    if ( window.widget ) {
        widget.onhide = stopMonitor;
        widget.onshow = startMonitor;
    }

    userName = ProcessKiller.getUserName();
//    debug( userName );
    
    //setTimeout( showRunningProcesses, 0 );
    startMonitor();

    scroller = new Scroller( document.getElementById( "tableFrame" ), 
                             document.getElementById( "tableContainer" ),
                             document.getElementById( "track" ),
                             document.getElementById( "thumb" ) );

    createButton( document.getElementById( "killbutton" ), "Kill", kill );
}


function stopMonitor() {
    if ( refreshTimer != null ) {
        clearInterval( refreshTimer );
        refreshTimer = null;
    }
}

function startMonitor() {
    if ( refreshTimer != null ) return;
//         clearInterval( refreshTimer );
//         refreshTimer = null;
//     }
    refreshTimer = setInterval( showRunningProcesses, refreshInterval );
    setTimeout( showRunningProcesses, 50 );
    //showRunningProcesses();
}

function _tableData( text ) {
    var datum = document.createElement( "td" );
    datum.appendChild( document.createTextNode( text ) );
    return datum;
}

function Process( user, number, cpu, name ) {
    this.user = user;
    this.number = number;
    this.cpu = cpu;
    this.name = name;
    if ( name.length > maxNameLength ) {
        this.name = name.substring( 0, maxNameLength - 2 ) + "..";
    }
    //debug( this.user + " " + this.number + " " + this.cpu + " " + this.name );
    if ( selectedProcess != null &&  this.number == selectedProcess.number ) {
        this.selected = true;
    } else {
        this.selected = false;
    }
    if ( this.number == "PID" ) {
        this.number = null;
        this.selected = false;
    }
    this.createLabel = function() {
        var div = document.createElement( "div" );
        if ( this.selected ) {
            div.style.background = selectedBackground;
            div.style.color = selectedForeground;
        }
        div.setAttribute( "class", "row" );
        if ( this.number ) {
            div.addEventListener( "click", changeColor );
        }
        var user = document.createElement( "div" );
        user.appendChild( document.createTextNode( this.user ) );
        user.setAttribute( "class", "user" );
        div.appendChild( user );
        var cpu = document.createElement( "div" );
        cpu.appendChild( document.createTextNode( this.cpu ) );
        cpu.setAttribute( "class", "cpu" );
        div.appendChild( cpu );
        var process = document.createElement( "div" );
        process.appendChild( document.createTextNode( this.name ) );
        process.setAttribute( "class", "process" );
        div.appendChild( process );
        div.processObject = this;
        return div;
    }
}

function changeColor( event ) {
    // set as element
    var elem = event.srcElement;
    if ( elem.nodeType != 1 ) {
        elem = elem.parentNode;
    }
    if ( elem.nodeType != 1 ) return;

    while ( elem.getAttribute( "class" ) != "row" ) {
        elem = elem.parentNode;
        if ( elem == null || elem == undefined ) {
            debug( "no valid element" );
            return;
        }
    }

    // clear current color
    var table = document.getElementById( "processTable" );
    var children = table.childNodes;
    for ( var i = 0; i < children.length; i++ ) {
        children.item( i ).style.background = "none";
        children.item( i ).style.color = "white";

    }

    elem.style.background = selectedBackground;
    elem.style.color = selectedForeground;

    //debug( "get processname" + elem.firstChild + " , " + elem.firstChild.firstChild );
    selectedProcess = elem.processObject;

}

function kill() {
    if ( selectedProcess ) {
        //debug( selectedProcess.user + " / " + userName );
        if ( selectedProcess.user == userName ) {
            debug( "kill user process" );
            ProcessKiller.killUserProcess( parseInt( selectedProcess.number ) );
        } else {
            debug( "kill root process" );
            ProcessKiller.killProcess( parseInt( selectedProcess.number ) );
//            debug( "kill " + selectedProcess.number + " by " + selectedProcess.user );
        }
        stopMonitor();
        startMonitor();
    }
}

var runningFlag = false;
function showRunningProcesses() {
    if ( runningFlag ) {
        return;
    }
    runningFlag = true;
    try {
        var ps = ProcessKiller.getRunningProcesses();
        var rows = ps.split( "\n" );
        var table = document.getElementById( "processTable" );
        if ( table ) {
            while ( table.lastChild ) table.removeChild( table.lastChild );
            for ( var i = 0; i < rows.length - 2; i++ ) {
                var items = rows[ i ].split( /\s+/ );
                if ( items.length < 11 ) continue;
                var user = items[ 0 ];
                var cpu  = items[ 2 ];
                var item = items[ 11 ];
                for ( var j = 12; j < items.length; j++ ) {
                    item += " " + items[ j ];
                }
//             if ( items.length >= 13 ) {
//                 debug( item + " <= " + items[ 11 ] );
//             }
                var dn = item.split( "/" );
                item = dn[ dn.length - 1 ];
                var name = item;
                var number = items[ 1 ];
                var proc = new Process( user, number, cpu, name );
                table.appendChild( proc.createLabel() );
                //_tableData( item ) );
                //table.appendChild( relem );
                //relem.addEventListener( "click", debug( "clicked " ) );
            }
        }
    } catch ( e ) {
        debug( e );
    }
    if ( scroller ) {
        scroller.refresh();
    }
    runningFlag = false;
}
